#include <stdint.h>
#include <proc.h>
#include <memory.h>

struct swtch_stack
{
    uint64_t RBP;
    uint64_t RBX;
    uint64_t R12;
    uint64_t R13;
    uint64_t R14;
    uint64_t R15;
    uint64_t RBP2;
    uint64_t ret;
};

static uint64_t next_pid = 1;

struct process *current_proc;

struct process *new_process(void (*function)(void))
{
    struct process *p = P2V(pmm_calloc());
    p->pid = next_pid++;
    p->stack_ptr = incptr(p, PAGE_SIZE - sizeof(struct swtch_stack));
    p->q_next = 0;
    p->P4 = new_P4();

    struct swtch_stack *stck = p->stack_ptr;
    stck->RBP = (uint64_t)&stck->RBP2;
    stck->ret = (uint64_t)function;

    return p;
}

struct process *proc()
{
    return current_proc;
}